import sys
import argparse
from storm.locals import *
from email import message_from_file, message_from_string
from archiver.HyperArch import T
from i18n import initialize

initialize()
from core.i18n import _
#command: /bin/echo "/usr/bin/mhonarc -add -dbfile $PRIVATE_ARCHIVE_FILE_DIR/${listname}.mbox/mhonarc.db  
#-outdir $VAR_DIR/mhonarc/${listname} -stderr $LOG_DIR/mhonarc -stdout $LOG_DIR/mhonarc -spammode -umask 022"
#mhonarc -mbox
#$prefix/archives/private/yourmaillist.mbox/yourmaillist.mbox

#add a message into archives
def add(args, archiver):    
    #take msg as string from stdin
#    msg = message_from_string("""\
#From: "Dushyant" <db1@lists.example.org>
#To: test14@lists.example.com
#Subject: Re: new2  archived message
#Message-ID: <12460>
#In-Reply-To: <12459>
#Hi. this is the fist message
#""")
    msg = sys.stdin.read()
    print msg
    msg = message_from_string(msg)
    #Archive message
    archiver.archiveMsg(msg)
    
#convert a mbox file into sqlite db
def convert(args, archiver):
    archiver.mboxToDB(args.mbox)
        
def main():
    """bin/archiver"""
    # Create the basic parser and add all globally common options.
    parser = argparse.ArgumentParser(
        description="""ArchiverUI: Archives and manages messages from mailman mlists""",
        formatter_class=argparse.RawDescriptionHelpFormatter)
    
    parser.add_argument(
        '-v', '--version',
        action='version', version='1.0',
        help=_('Print this version string and exit'))
    
    parser.add_argument(
        '-C', '--config',
        help=_("""\
        Configuration file to use.  If not given, the environment variable
        MAILMAN_CONFIG_FILE is consulted and used if set.  If neither are
        given, a default configuration file is loaded."""))
    
    parser.add_argument(
        '-basedir', help=_('Specify the base directory which contains archives'))
    
    parser.add_argument(
        '-listname', help=_('Specify the listname to which this message belongs'))
   
    subparsers = parser.add_subparsers(title='Commands', 
                                   description='valid subcommands',
                                   help='additional help')
    
    add_parser = subparsers.add_parser('add', help='add a message to the archives')
    add_parser.set_defaults(func=add)
    
    convert_parser = subparsers.add_parser('convert', help='convert a mbox file containing messages into archives db')
    convert_parser.set_defaults(func=convert)
    convert_parser.add_argument(
        '-mbox', help=_('Specify the mbox file to be updated'))
    
    args = parser.parse_args()
    print type(args)
    if len(args.__dict__) == 0:
        # No arguments or subcommands were given.
        parser.print_help()
        parser.exit()
#    # Before actually performing the subcommand, we need to initialize the
#    # Mailman system, and in particular, we must read the configuration file.
#    config_file = os.getenv('MAILMAN_CONFIG_FILE')
#    if config_file is None:
#        config_file = args.config
#    initialize(config_file)
#    # Perform the subcommand option.
#    args.func(args)
    
    archiver  = HyperArch.T(basedir = args.basedir, mlist = args.listname)
    archiver.db_init()
#    args['msg'] = sys.stdin.read()
    args.func(args, archiver)

if __name__ == "__main__":
    main()