from storm.locals import *

class Reference(object):
    __storm_table__ = "reference"
    id = Int(primary = True)
    msgid = Unicode()
    refid = Unicode()

class StormArticle(object):
    """ Class to represent an Article in a sqlite database rather than using pickles. """
    __storm_table__ = "article"
    id = Int(primary=True)
    subject = Unicode()
    date = Float()
    datestr = Unicode()
    author = Unicode()
    email = Unicode()
    msgid = Unicode()
    in_reply_to = Unicode()
    body = Unicode() #lines separated by '\n'
    thread_addr = Unicode()
    threadkey = Unicode()
    pdate_msg = Int()
    ndate_msg = Int()
    pthread_msg = Int()
    nthread_msg = Int()
    references = ReferenceSet(id, Reference.msgid)
    
    def __init__(self, subject, date, datestr, author, email, msgid, in_reply_to, body, thread_addr, threadkey):
        self.subject = unicode(subject)
        self.date = date
        self.datestr = unicode(datestr)
        self.author = unicode(author)
        self.email = unicode(email)
        self.msgid = unicode(msgid)
        self.in_reply_to = unicode(in_reply_to)
        self.body = unicode(body)
        self.thread_addr = unicode(thread_addr)
        self.threadkey = unicode(threadkey)
